/**
 * Helper class that will map roles a user has to a list of xMatters roles. Each role can have
 * zero or one associated xMatters roles
 *
 */
var UserRolesMapper = BaseClass.extend({

    LOG_SOURCE: "userRolesMapper.js: ",

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Constructor
     *
     * -----------------------------------------------------------------------------------------------------------------
     */
    init: function()
    {
        this.log = new Logger(this.LOG_SOURCE);
        this.log.debug("UserRolesMapper constructed.");
    },

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * getXmUserRolesFor
     *
     * Returns a list of the xMatters roles corresponding to the Remedy support group roles that the user has.
     *
     * -----------------------------------------------------------------------------------------------------------------
     */
    getXmUserRolesFor: function(sdmRolesList)
    {
        this.log.info("Enter - getXmUserRolesFor");
        this.log.info("sdmRolesList [" + sdmRolesList + "]");

        var xmUsersRolesList = DEFAULT_XMATTERS_ROLES;

        if (!MAP_USER_ROLES)
        {
            this.log.info("MAP_USER_ROLES is false");
        }
        else if (sdmRolesList == null)
        {
            this.log.debug("No getListValues found");
        }
        else
        {
            this.log.debug("sdmRolesList length [" + sdmRolesList.length + "]");

            for each (var sdmRole in sdmRolesList)
            {
                this.log.debug("sdmRole [" + sdmRole + "]");

                var mappedRoles = roleMap[sdmRole];
                
                if (!isEmpty(mappedRoles))
                {
                  xmUsersRolesList = xmUsersRolesList.concat(mappedRoles);
                }
                this.log.debug("XM Roles: " + xmUsersRolesList);
            }
        }

        this.log.info("xmUsersRolesList " + "[" + xmUsersRolesList + "]");
        this.log.info("Exit - getXmUserRolesFor");

        return xmUsersRolesList;
    }

});

