<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page isELIgnored ="false" %> 

<%@ taglib uri="http://alarmpoint.com/alarmpoint/3.0#mobilegateway" prefix="esr" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
<%@ taglib uri="http://java.sun.com/jsp/jstl/xml" prefix="x"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %> 

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />
<jsp:useBean id="dateValue" class="java.util.Date" />

<html>
  <head>
    <fmt:setBundle basename="resources/caservicedesk/caservicedesk" var="msg"/>

    <c:choose>
      <c:when test="${param.ticketType == 'chg'}">
        <c:set var="categoryObject" value="chgcat"/>
      </c:when>
      <c:when test="${param.ticketType == 'iss'}">
        <c:set var="categoryObject" value="isscat"/>
      </c:when>
      <c:otherwise>
        <c:set var="categoryObject" value="pcat"/>
      </c:otherwise>
    </c:choose>

    <!-- Free any previous list handle -->
    <esr:request action="freeListHandle" service="caservicedesk" domain="caservicedesk">
      <esr:argument name="sid" type="string">${sessionScope.sid}</esr:argument>
      <esr:argument name="username" type="string">${sessionScope.casdmUsername}</esr:argument>
      <esr:argument name="password" type="string">${sessionScope.casdmPassword}</esr:argument>
      <esr:argument name="listHandle" type="string">${param.listHandle}</esr:argument>
    </esr:request>

    <esr:request action="getStatuses" service="caservicedesk" domain="caservicedesk">
      <esr:argument name="sid" type="string">${sessionScope.sid}</esr:argument>
      <esr:argument name="username" type="string">${sessionScope.casdmUsername}</esr:argument>
      <esr:argument name="password" type="string">${sessionScope.casdmPassword}</esr:argument>
      <esr:argument name="objectType" type="string">${param.ticketType}</esr:argument>
    </esr:request>
    <c:set var="statusXml">${pageScope.result.response}</c:set>
    <x:parse var="statuses" doc="${statusXml}" scope="session"/>

    <c:if test="${param.searchTicket != null}">
    
      <!-- Handle the use case of whether the user has populated the requester/assignee/group
           with a valid value using autocomplete. If not, send the entered value in the query -->
      <c:choose>
        <c:when test="${empty param.requesterId && !empty param.requester}">
          <c:set var="requester_name" value="${param.requester}"/>
        </c:when>
        <c:otherwise>
          <c:set var="requester_name" value="${param.requesterId}"/>
        </c:otherwise>
      </c:choose>

      <c:choose>
        <c:when test="${empty param.assigneeId && !empty param.assignee}">
          <c:set var="assignee_name" value="${param.assignee}"/>
        </c:when>
        <c:otherwise>
          <c:set var="assignee_name" value="${param.assigneeId}"/>
        </c:otherwise>
      </c:choose>

      <c:choose>
        <c:when test="${empty param.groupId && !empty param.group}">
          <c:set var="group_name" value="${param.group}"/>
        </c:when>
        <c:otherwise>
          <c:set var="group_name" value="${param.groupId}"/>
        </c:otherwise>
      </c:choose>

      <c:catch var="searchTicketException">
        <esr:request action="searchTickets" service="caservicedesk" domain="caservicedesk">
          <esr:argument name="sid" type="string">${sessionScope.sid}</esr:argument>
          <esr:argument name="username" type="string">${sessionScope.casdmUsername}</esr:argument>
          <esr:argument name="password" type="string">${sessionScope.casdmPassword}</esr:argument>
          <esr:argument name="objectType" type="string">${param.ticketType}</esr:argument>
          <esr:argument name="ref_num" type="string">${param.ref_num}</esr:argument>
          <esr:argument name="chg_ref_num" type="string">${param.ref_num}</esr:argument>
          <esr:argument name="requester" type="string">${requester_name}</esr:argument>
          <esr:argument name="status" type="string">${param.newstatus}</esr:argument>
          <esr:argument name="impact" type="string">${param.newimpact}</esr:argument>
          <esr:argument name="urgency" type="string">${param.newurgency}</esr:argument>
          <esr:argument name="assignee" type="string">${assignee_name}</esr:argument>
          <esr:argument name="group" type="string">${group_name}</esr:argument>
          <esr:argument name="counts" type="string">true</esr:argument>
        </esr:request>
        <x:parse var="tickets" doc="${pageScope.result.response}"/>
        <x:set var="ticketCount" select="string($tickets//listLength)"/>
        <x:set var="listHandle" select="string($tickets//listHandle)"/>
      </c:catch>
    </c:if>

    <c:if test="${empty param.searchTicket || !empty searchTicketException}">
      <c:set var="ticketCount" value="1"/>
    </c:if>
    
    <c:url var="searchTicketsUrl" value="getTicketList.jsp" >
      <c:param name="ticketType" value="${param.ticketType}" />
      <c:param name="ref_num" value="${param.ref_num}" />
      <c:param name="requester" value="${requester_name}" />
      <c:param name="newstatus" value="${param.newstatus}" />
      <c:param name="newimpact" value="${param.newimpact}" />
      <c:param name="newurgency" value="${param.newurgency}" />
      <c:param name="assigneeId" value="${assignee_name}" />
      <c:param name="groupId" value="${group_name}" />
      <c:param name="listHandle" value="${listHandle}" />
      <c:param name="listLength" value="${ticketCount}" />
    </c:url>

    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <title><fmt:message key="screen.title" bundle="${msg}"/></title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <script src="/mg/includes/javascript/jquery-1.4.4.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.core.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.widget.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.position.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.autocomplete.js"></script>
  	<script src="/mg/includes/javascript/jquery.ui.accordion.js"></script>
  	<script src="/mg/includes/javascript/jquery.pagination.js"></script>

    <style>
      .ui-autocomplete-loading { background: white url('images/ui-anim_basic_16x16.gif') right center no-repeat; }
    </style>

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/caservicedesk.css");
      label.required {
      	font-weight: bold;
      	color: #990033;
      }
    </style>

    <script type="text/javascript">

      var count = 0;
      var chunkSize = 10;
      var startIndex = 0;

      $(function(){
        
        var ajaxCall = function( endpoint, objectType, fieldName1, fieldName2, fieldName3, keyField, valueField ) {
          return (function( request, response ) {
            $.ajax({
              url: endpoint,
              dataType: "xml",
              data: {
                param1: request.term,
                param2: objectType,
                param3: fieldName1,
                param4: fieldName2,
                param5: fieldName3
              },
              success: function( data ) {
                var results = parseXml( data, keyField, valueField );
					      response( $.map( results, function( item ) {
						      return {
							      id: item.id,
							      value: item.value
						      }
					      }));
              }
            });
          });
        };

        function parseXml( data, keyField, valueField ) {
          var results = [];
          $(data).find('record').each(function() {
              results[results.length] = { 
                id: $.trim($(this).find(keyField).text()),
                value: $.trim($(this).find(valueField).text())
              };
          });
          return results;
        }

        var styleField = function(oldClass, newClass) {
          $( this ).removeClass( oldClass ).addClass( newClass );
        };

        $( "#requester" ).autocomplete({
          source: ajaxCall( "<c:url value='search.jsp' />", "cnt", "userid", "first_name", "last_name", "userid", "combo_name" ),
          minLength: 2,
          select: function( event, ui ) {
            $('#requesterId').val(ui.item.id);
          },
          change: function( event, ui) {
            if (!ui.item) {
              $('#requesterId').val("");
            }
          },
          open: styleField( "ui-corner-all", "ui-corner-top" ),
          close: styleField( "ui-corner-top", "ui-corner-all" )
        });

        $( "#assignee" ).autocomplete({
          source: ajaxCall( "<c:url value='search.jsp' />", "cnt", "userid", "first_name", "last_name", "userid", "combo_name" ),
          minLength: 2,
          select: function( event, ui ) {
            $('#assigneeId').val(ui.item.id);
          },
          change: function( event, ui) {
            if (!ui.item) {
              $('#assigneeId').val("");
            }
          },
          open: styleField( "ui-corner-all", "ui-corner-top" ),
          close: styleField( "ui-corner-top", "ui-corner-all" )
        });

        $( "#group" ).autocomplete({
          source: ajaxCall( "<c:url value='search.jsp' />", "grp", "last_name", "", "", "last_name", "combo_name" ),
          minLength: 2,
          select: function( event, ui ) {
            $('#groupId').val(ui.item.id);
          },
          change: function( event, ui) {
            if (!ui.item) {
              $('#groupId').val("");
            }
          },
          open: styleField( "ui-corner-all", "ui-corner-top" ),
          close: styleField( "ui-corner-top", "ui-corner-all" )
        });

        $('.more').live("click", function() {
          
          startIndex = count * chunkSize;
          if (startIndex < parseInt(${ticketCount}) )
          {
            $("#more").html('<td colspan="4"><a class="loading">Load More...<img src="/mg/images/mobile/spinner.gif" style="padding-left: 20px;" height="18" width="18"></a></td>');

            $.ajax({
              type: "POST",
              url: "${searchTicketsUrl}",
              data: {
                startIndex: startIndex,
                chunkSize: chunkSize
              },
              cache: false,
              success: function(html) {  
                $("#more").remove(); // Remove the old more button
                $("#ticketList").append(html);
              }
            });
          }
          else
          {
            $("#more").remove(); // Remove the old more button
          }
          count++;
          return false;
        })
        $('.more').click();
        
        // Set the values for the autocomplete. If the autocomplete does not find
        // a valid value OR the value is not populated as a result of the autocomplete,
        // set the field values according to the text field. If the text field is blank,
        // ensure the other associated fields are blanked out.
        function setValue(currentId, current) {
          if (current.val()=="") {
            currentId.val("");
          }       
        }

        $( "#target").submit(function() {
          setValue($("#assigneeId"), $("#assignee"));
          setValue($("#groupId"), $("#group"));
          setValue($("#requesterId"), $("#requester"));
        });
        
         
        // JQuery Callback to initialize the activity list
        <c:if test="${!empty param.searchTicket && empty searchTicketException}">
          initPagination();
        </c:if>

      });

    </script>
    
  </head>
  <body>
    <div id="content">
      <div class="main box">
        <h1><fmt:message key="management.system" bundle="${msg}"/>&nbsp;<fmt:message key="ticket.type.${param.ticketType}" bundle="${msg}"/></h1>
        <div class="lining">
          <c:url var="searchTicket" value="searchTicket.jsp" />
        
          <c:if test="${!empty searchTicketException}">
            <div class="alert-message" > 
              <c:choose>
                <c:when test="${fn:indexOf(searchTicketException.message,'ticket.search.empty') != -1}">
                  <fmt:message key="ticket.search.empty" bundle="${msg}"/>
                </c:when>
                <c:otherwise>
                  <fmt:message key="invalid.search.parameter" bundle="${msg}">
                    <fmt:param value=" ${fn:replace(searchTicketException.message, sessionScope.exceptionString, '')}"/>
                  </fmt:message>
                </c:otherwise>
              </c:choose>
            </div>
          </c:if>
          <c:if test="${ticketCount == '0'}">
            <div class="alert-message" > 
              <fmt:message key="ticket.no.results" bundle="${msg}"/>
            </div>
          </c:if>
          
          <form id="target" method="post" action="${searchTicket}">
            <h2><fmt:message key="screen.search" bundle="${msg}"/> &nbsp;<fmt:message key="ticket.type.${param.ticketType}" bundle="${msg}"/></h2>
            <div>
              <input type="hidden" id="ticketType" name="ticketType" value="${param.ticketType}"/>
              <div class="details">
                <label for="ref_num"><fmt:message key="ticket.number" bundle="${msg}"/>:</label>
                <input id="ref_num" name="ref_num" value="${param.ref_num}"/>
              </div>
              <c:if test="${param.ticketType != 'iss'}">
                <div class="details">
                  <label for="requester"><fmt:message key="ticket.requester.${param.ticketType}" bundle="${msg}"/>:</label>
                  <input id="requester" name="requester" value="${param.requester}"/>
                  <input type="hidden" id="requesterId" name="requesterId" value="${param.requesterId}"/>
                </div>
              </c:if>
              <div class="details">
                <label for="status"><fmt:message key="ticket.status" bundle="${msg}"/>:</label>
                <span id="status">
                  <select id="newstatus" name="newstatus">
                    <option value=""></option>
                    <x:forEach var="status" select="$sessionScope:statuses//status">
                      <x:set var="statusCode" select='string($status/@code)'/>
                      <c:choose>
                        <c:when test="${param.newstatus == statusCode}" >
                          <option value="<x:out select='string($status/@code)'/>" selected="selected"><x:out select='string($status)'/></option>
                        </c:when>
                        <c:otherwise>
                          <option value="<x:out select='string($status/@code)'/>"><x:out select='string($status)'/></option>
                        </c:otherwise>
                      </c:choose>
                    </x:forEach>
                  </select>
                </span>
              </div>
              <c:if test="${param.ticketType != 'chg' && param.ticketType != 'iss'}">
                <div class="details">
                  <label for="urgency"><fmt:message key="ticket.urgency" bundle="${msg}"/>:</label>
                  <span id="urgency">
                    <select id="newurgency" name="newurgency">
                      <option value=""></option>
                      <x:forEach var="urgency" select="$sessionScope:urgencyList//record">
                        <x:set var="urgencyCode" select='string($urgency/enum)'/>
                        <c:choose>
                          <c:when test="${param.newurgency == urgencyCode}" >
                            <option value="<x:out select='$urgency/enum'/>" selected="selected"><x:out select="$urgency/sym"/></option>
                          </c:when>
                          <c:otherwise>
                            <option value="<x:out select='$urgency/enum'/>"><x:out select="$urgency/sym"/></option>
                          </c:otherwise>
                        </c:choose>
                      </x:forEach>
                    </select>
                  </span>
                </div>
              </c:if>
              <div class="details">
                <label for="impact"><fmt:message key="ticket.impact" bundle="${msg}"/>:</label>
                <span id="impact">
                  <select id="newimpact" name="newimpact">
                    <option value=""></option>
                    <x:forEach var="impact" select="$sessionScope:impactList//record">
                      <x:set var="impactCode" select='string($impact/enum)'/>
                      <c:choose>
                        <c:when test="${param.newimpact == impactCode}" >
                          <option value="<x:out select='$impact/enum'/>" selected="selected"><x:out select="$impact/sym"/></option>
                        </c:when>
                        <c:otherwise>
                          <option value="<x:out select='$impact/enum'/>"><x:out select="$impact/sym"/></option>
                        </c:otherwise>
                      </c:choose>
                    </x:forEach>
                  </select>
                </span>
              </div>
              <div class="details">
                <label for="group"><fmt:message key="ticket.group" bundle="${msg}"/>:</label>
                <input id="group" name="group" value="${param.group}"/>
                <input type="hidden" id="groupId" name="groupId" value="${param.groupId}"/>
              </div>
              <div class="details">
                <label for="assignee"><fmt:message key="ticket.assignee" bundle="${msg}"/>:</label>
                <input id="assignee" name="assignee" value="${param.assignee}"/>
                <input type="hidden" id="assigneeId" name="assigneeId" value="${param.assigneeId}"/>
              </div>
            </div>
            <input type="submit" name="searchTicket" class="button" value="<fmt:message key='button.search' bundle='${msg}'/>"/>
          </form>
        </div>
      </div>
      <c:if test="${!empty param.searchTicket && empty searchTicketException && ticketCount != '0'}">
        <div class="main box">
          <h1>Results (${ticketCount})</h1>
          <div class="lining">          
            <table width="100%">
              <thead>
                <tr>
                  <th><fmt:message key="ticket.number" bundle="${msg}"/></th>
                  <th><fmt:message key="ticket.status" bundle="${msg}"/></th>
                  <th><fmt:message key="ticket.priority" bundle="${msg}"/></th>
                  <th><fmt:message key="ticket.summary" bundle="${msg}"/></th>
                </tr>
              </thead>
              <tbody id="ticketList">
                <tr id="more">
                  <td><a href="#" class="more">Load More...</a></td>
                </tr>            
              </tbody>
            </table>
          </div>
        </div>
      </c:if>
    </div>
    <jsp:include page="footer.jsp"/>
  </body>
</html>
