<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<%@ page contentType="text/html;charset=UTF-8"%>
<%@ page isELIgnored ="false" %> 

<%@ taglib uri="http://alarmpoint.com/alarmpoint/3.0#mobilegateway" prefix="esr" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 
<%@ taglib uri="http://java.sun.com/jsp/jstl/xml" prefix="x"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %> 
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession" id="mobileGatewaySession" scope="session" />
<jsp:useBean id="dateValue" class="java.util.Date" />

<html>
  <head>
    <fmt:setBundle basename="resources/caservicedesk/caservicedesk" var="msg"/>

    <c:url var="addActivity" value="addActivity.jsp">
      <c:param name="ticketType" value="${param.ticketType}"/>
      <c:param name="objectHandle" value="${param.objectHandle}"/>
      <c:param name="refNum" value="${param.refNum}"/>
      <c:param name="mustComment" value="false"/>
    </c:url>

    <c:url var="showTicket" value="showTicket.jsp">
      <c:param name="ticketType" value="${param.ticketType}"/>
      <c:param name="persistent_id" value="${param.objectHandle}"/>
    </c:url>

    <!-- Retrieve the activity log count from CA SDM -->
    <esr:request action="getRelatedList" service="caservicedesk" domain="caservicedesk">
      <esr:argument name="sid" type="string">${sessionScope.sid}</esr:argument>
      <esr:argument name="username" type="string">${sessionScope.casdmUsername}</esr:argument>
      <esr:argument name="password" type="string">${sessionScope.casdmPassword}</esr:argument>
      <esr:argument name="objectHandle" type="string">${param.objectHandle}</esr:argument>
      <esr:argument name="listName" type="string">act_log_all</esr:argument>
    </esr:request>
    <c:set var="activityXml">${pageScope.result.response}</c:set>
    <x:parse var="activityDetails" doc="${activityXml}"/>
    <x:set var="activityCount" select="string($activityDetails//listLength)"/>
    <x:set var="listHandle" select="string($activityDetails//listHandle)"/>

    <c:url var="searchActivitiesUrl" value="searchActivities.jsp" >
      <c:param name="persistent_id" value="${param.objectHandle}" />
      <c:param name="ticketType" value="${param.ticketType}" />
      <c:param name="listLength" value="${activityCount}" />
      <c:param name="listHandle" value="${listHandle}" />
    </c:url>
    
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <title><fmt:message key="screen.title" bundle="${msg}"/></title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />

    <script src="/mg/includes/javascript/jquery-1.4.4.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.core.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.widget.js"></script>
    <script src="/mg/includes/javascript/jquery.ui.position.js"></script>
    <style type="text/css" media="all" title="xMatters mobile access">
      .ui-autocomplete-loading { background: white url('images/ui-anim_basic_16x16.gif') right center no-repeat; }
    </style>

    <style type="text/css" media="all" title="xMatters mobile access">
      @import url("/mg/css/caservicedesk.css");
      label.required {
      	font-weight: bold;
      	color: #990033;
      }

    </style>
    <script type="text/javascript">
      var count = 0;
      var chunkSize = 10;
      var startIndex = 0;
     
      $(function(){
        $('.more').live("click", function() {
          
          startIndex = count * chunkSize;
          if (startIndex < parseInt(${activityCount}) )
          {
            $("#more").html('<td><a class="loading">Load More...<img src="/mg/images/mobile/spinner.gif" style="padding-left: 20px;" height="18" width="18"></a></td>');

            $.ajax({
              type: "POST",
              url: "${searchActivitiesUrl}",
              data: {
                startIndex: startIndex,
                chunkSize: chunkSize
              },
              cache: false,
              success: function(html) {  
                $("#more").remove(); // Remove the old more button
                $("#activityList").append(html);
              }
            });
          }
          else
          {
            $("#more").remove(); // Remove the old more button
          }
          count++;
          return false;
        })
        $('.more').click();
      });
      
    </script>
    
  </head>
  <body>
    <div id="content">
      <div class="main box">
        <fmt:message var="ticketTypeDesc" key="ticket.type.${param.ticketType}" bundle="${msg}"/>
        <h1>${ticketTypeDesc}&nbsp;${param.refNum}&nbsp;<fmt:message key="screen.activities" bundle="${msg}"/> (${activityCount})</h1>
        <div class="lining">
          <table width="100%">
            <thead>
              <tr>
                <th><fmt:message key="activity.created.by" bundle="${msg}"/>&nbsp;/&nbsp;<fmt:message key="activity.description" bundle="${msg}"/></th>
              </tr>
            </thead>
            <tbody id="activityList">
              <tr id="more">
                <td><a href="#" class="more">Load More...</a></td>
              </tr>            
            </tbody>
          </table>
        </div>
        <fmt:message var="showTicketDesc" key="button.show.ticket" bundle="${msg}">
          <fmt:param value="${ticketTypeDesc}"/>
        </fmt:message>
        <input type="button" class="button" name="updateTicket" value="<fmt:message key='button.add.activity' bundle='${msg}'/>" onclick="location.href='${addActivity}'"/>
        <input type="button" class="button" name="back" value="${showTicketDesc}" onclick="location.href='${showTicket}'"/>
      </div>
    </div>
    <jsp:include page="footer.jsp"/>
  </body>
</html>
