<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.view.MobileGatewayUser"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.invoqsystems.apex.model.agent.integration.IntegrationService"%>
<%@ page import="com.invoqsystems.apex.model.agent.integration.IntegrationServiceStatus"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"
             id="mobileGatewaySession"
             scope="session" />

<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />

    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />
    
    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("/mg/css/caservicedesk.css");
    </style>
  </head>

  <body>
  
  <a id="top" name="top"></a>
  
  <!---+
       + Header 
       +--->
  <div id="header">
    <img src="/mg/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
  </div>
  
  <!---+
       + Main content 
       +--->
  <div id="content">
    <div class="main box">
      <h1>Integration Services</h1>
      <div class="lining">
  <%
      MobileGatewayUser user = mobileGatewaySession.getUser();
      List<IntegrationService> accessibleServices = user.getAccessibleServices();
  %>

  <%
     if(accessibleServices.isEmpty())
     {
  %>
        <div class="msg-error">There are no Services available for your user account.</div>
  <%
     }
     else if(accessibleServices.size() == 1 && 
             accessibleServices.get(0).getHomePage() != null &&
             accessibleServices.get(0).getHomePage().length() > 0)
     {
        response.sendRedirect(response.encodeURL(accessibleServices.get(0).getHomePage()));
     } 
     else
     {
  %>
          <table width="100%">
            <tr>
              <th>Name</th>
              <th>Status</th>
            </tr>
  <%
         for(IntegrationService service: accessibleServices)
         {
  %>
            <tr>
  <%
            long threshold = mobileGatewaySession.getHeartbeatThreshold();
            IntegrationServiceStatus status = service.getStatus(threshold);

             if(service.getHomePage() != null && 
                service.getHomePage().length() > 0 &&
                status == IntegrationServiceStatus.ACTIVE) 
             {
  %>
              <td><a href="<%=response.encodeURL(service.getHomePage())%>"><%=service.getName() %></a></td>
  <%
             } 
             else 
             {
  %>
              <td><%=service.getName() %></td>
  <% 
             }
  %>
              <td><%=status.toString() %></td>
            </tr>
  <%
         }
  %>
          </table>
  <%
       }
  %>
      </div>
    </div>
  </div>

     <!---+
         + Footer 
         +--->
    <div id="footer">
      <div class="footer-links">
        <a href="<%=response.encodeURL("logout.jsp")%>">Logout</a>
      </div>      
    </div>
    

  </body>
</html>
 
