<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointNonMobileUserException"%>
<%@ page import="com.invoqsystems.apex.exceptions.AlarmPointDatabaseException"%>

<jsp:useBean class="com.alarmpoint.apex.mobilegateway.util.MobileGatewaySession"
             id="mobileGatewaySession"
             scope="session" />
<%
     String contextPath = request.getContextPath();
%>


<!DOCTYPE html PUBLIC "-//OMA//DTD XHTML Mobile 1.0//EN" "http://www.openmobilealliance.org/tech/DTD/xhtml-mobile10.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>xMatters mobile access</title>
    <link rel="SHORTCUT ICON" href="/mg/images/logos/xmatters/favicon.ico" type="image/x-icon" />
    
    
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="Cache-Control" content="max-age=0" />
    <meta http-equiv="Pragma" content="no-cache" />
    <meta http-equiv="Expires" content="-1" />
    <!-- IE Mobile Meta Tag (optimized for 100% of the screen width) -->
    <meta name="MobileOptimized" content="100" />
    
    <style type="text/css" media="all" title="AlarmPoint Mobile Gateway">
      @import url("<%=contextPath%>/css/caservicedesk.css");
    </style>
    
  </head>
  <body>
  
  <a id="top" name="top"></a>
  
  <!---+
       + Header 
       +--->
  <div id="header">
    <img src="<%=contextPath%>/images/misc/spacer.gif" height="35" width="100" id="logo" name="logo" alt="AlarmPoint Mobile Gateway" border="0" align="right" />
  </div>
  
  <!---+
       + Main content 
       +--->
  <div id="content">
    <div class="main box">
      <h1>xMatters mobile access</h1>

  <%
      String user = request.getParameter("user");
      String password = request.getParameter("password");
      String company = request.getParameter("company");
      if (company == null || company.isEmpty())
      {
          company = "Default Company";
      }

      if(user != null || password != null)
      {
          boolean loginSuccess = false;
          boolean exceptionThrown = false;
          try 
      {
              loginSuccess = mobileGatewaySession.authenticateUser(user, password, company);
          } 
          catch(AlarmPointNonMobileUserException e) 
          {
              exceptionThrown = true;
  %>
              <div class="msg-error">Unauthorized mobile access.  Please contact your administrator.</div>
  <%
          } 
          catch(AlarmPointDatabaseException e) 
          {
              exceptionThrown = true;
  %>
              <div class="msg-error">Unable to connect to database.  Please contact your administrator.</div>
  <%
          } 
          catch(Throwable t) 
          {
              exceptionThrown = true;
  %>
              <div class="msg-error">Unexpected application error: <%=t.getMessage()%>.  Please contact your administrator.</div>
  <%
          }

        if(loginSuccess)
          {
        // set the session timeout to 30 minutes
        request.getSession().setMaxInactiveInterval(1800);
        session.setAttribute("mgPassword", request.getParameter("password"));
        
  %>
              <jsp:forward page="listServices.jsp"/>
  <%
          } 
          else if(exceptionThrown == false)
          {
  %>
            <br /><div class="msg-error">Invalid Username/Password/Company. Please try again.</div><br />
  <%
      }
      }
  %>

        <div class="lining">
          <form id="LoginForm" name="LoginForm" method="post" action="<%=response.encodeURL("login.jsp")%>">
            <div>
              <label for="user">Username:</label>
              <input type="text" name="user" id="user" value="<%=user != null ? user : ""%>" />
            </div>
            <div>
              <label for="password">Password:</label>
              <input type="password" name="password" id="password" />
            </div>
                
            <input type="submit" name="submit" id="submit" value="Login" class="button" /></td>
          </form>
        </div>
      </div>
    </div>

    <!---+
         + Footer 
         +--->
    <div id="footer">
      <div class="copyright">
        &copy; 2011 xMatters, inc.
      </div>
    </div>
  
  </body>
</html>
